You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

195 lines
6.3 KiB

5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
  1. #!/bin/bash
  2. set -e
  3. exec 3>&1 # make stdout available as fd 3 for the result
  4. exec 1>&2 # redirect all output to stderr for logging
  5. echo "BUILD_ID: $BUILD_ID"
  6. echo "BUILD_NAME: $BUILD_NAME"
  7. echo "BUILD_JOB_NAME: $BUILD_JOB_NAME"
  8. echo "BUILD_PIPELINE_NAME: $BUILD_PIPELINE_NAME"
  9. # shellcheck disable=1090
  10. source "$(dirname $0)/common.sh"
  11. source=$1
  12. if [[ -z "$source" ]]; then
  13. echo "usage: $0 <path/to/source>"
  14. exit 1
  15. fi
  16. # for jq
  17. PATH=/usr/local/bin:$PATH
  18. payload=$(mktemp "$TMPDIR/rclone-resource-request.XXXXXX")
  19. cat > "$payload" <&0
  20. load_config "$payload"
  21. load_files "$payload"
  22. rclone_source_directory=$(jq -r '.params.source // ""' < "$payload")
  23. rclone_destinations=$(jq -r '.params.destination[]? | .dir // ""' < "$payload")
  24. rclone_link_destination=$(jq -r '.params.linkDestination // ""' < "$payload")
  25. rclone_link_destination_subdir_file=$(jq -r '.params.linkDestinationSubDir // ""' < "$payload")
  26. if [[ -z "$rclone_source_directory" ]]; then
  27. echo "invalid source directory (missing source)"
  28. exit 1
  29. fi
  30. if [[ -z "$rclone_destinations" ]]; then
  31. echo "invalid destination (missing destination)"
  32. exit 1
  33. fi
  34. echo "Source directory: $rclone_source_directory"
  35. echo "Destinations:"
  36. jq -c '.params.destination[] | .dir' < "$payload"
  37. local_source_dir="${source}/${rclone_source_directory}"
  38. ls -alh "${local_source_dir}"
  39. echo "Generating SHA256"
  40. sha256_file="${TMPDIR}/rclone_source.sha256"
  41. touch "${sha256_file}"
  42. (find "${local_source_dir}" -type f -exec sha256sum {} \;) | cut -d ' ' -f1 | xargs echo >> "${sha256_file}"
  43. sha256=$(sha256sum "${sha256_file}" | cut -d' ' -f1)
  44. echo "sha256:${sha256}"
  45. # Source is always the same for each destination
  46. rclone_source="${local_source_dir}"
  47. echo "Source: ${rclone_source}"
  48. destinations=$(jq -r '.params.destination[] | @base64' < "$payload")
  49. echo "Using encoded destinations:"
  50. echo " ${destinations}"
  51. file_links=()
  52. for destination in $destinations; do
  53. _jq() {
  54. echo "${destination}" | base64 -d | jq -r "${1}"
  55. }
  56. rclone_destination=$(_jq '.dir')
  57. rclone_destination_subdir_file=$(_jq '.subdir // ""')
  58. rclone_command=$(_jq '.command // "copy"')
  59. rclone_args=$(_jq '.args // [] | join(" ")')
  60. rclone_dedupe=$(_jq '.dedupe // "false"')
  61. rclone_dedupe_mode=$(_jq '.dedupeMode // "newest"')
  62. rclone_link=$(_jq '.link // "false"')
  63. rclone_link_find_filter=$(_jq '.linkFilter // "-maxdepth 1 -type f"')
  64. rclone_allow_failure=$(_jq '.allowFailure // "false"')
  65. echo "Destination: $rclone_destination"
  66. echo "Destination subdir file: ${rclone_destination_subdir_file}"
  67. echo "Command: ${rclone_command}"
  68. echo "Additonal args: ${rclone_args}"
  69. echo "Run dedupe: ${rclone_dedupe}"
  70. echo "Dedupe mode: ${rclone_dedupe_mode}"
  71. echo "Generate link: ${rclone_link}"
  72. echo "Link find filter: ${rclone_link_find_filter}"
  73. echo "Allow failure: ${rclone_allow_failure}"
  74. if [[ "${rclone_allow_failure}" = "true" ]]; then
  75. set +e
  76. fi
  77. rclone_destination_subdir=""
  78. if [ -n "$rclone_destination_subdir_file" ]; then
  79. echo "Looking in ${source}/${rclone_destination_subdir_file} for subdir to use"
  80. rclone_destination_subdir=$(head -n 1 < "${source}/${rclone_destination_subdir_file}")
  81. fi
  82. if [[ -z "${rclone_destination_subdir}" ]]; then
  83. rclone_target="${rclone_destination}"
  84. else
  85. rclone_target="${rclone_destination}/${rclone_destination_subdir}"
  86. fi
  87. echo "Target: ${rclone_target}"
  88. # shellcheck disable=2086
  89. rclone ${rclone_command} "${rclone_source}" "${rclone_target}" --size-only --progress --stats=2s ${rclone_args}
  90. copy_rc=$?
  91. if [[ "${rclone_allow_failure}" = "true" && $copy_rc -gt 0 ]]; then
  92. echo "Rclone copy failed. Switching to next destination."
  93. continue
  94. fi
  95. if [[ "$rclone_dedupe" == "true" ]]; then
  96. echo "Running Dedupe for: ${rclone_target}"
  97. # shellcheck disable=2086
  98. rclone dedupe --dedupe-mode "${rclone_dedupe_mode}" "${rclone_target}" --progress --stats=2s ${rclone_args}
  99. dedupe_rc=$?
  100. if [[ "${rclone_allow_failure}" = "true" && $dedupe_rc -gt 0 ]]; then
  101. echo "Rclone dedupe failed. Switching to next destination."
  102. continue
  103. fi
  104. fi
  105. if [[ "${rclone_link}" == "true" ]]; then
  106. # shellcheck disable=2086
  107. filesToLink=$(find "${rclone_source}" ${rclone_link_find_filter})
  108. echo "Files to link:"
  109. echo "${filesToLink}"
  110. for file in ${filesToLink}; do
  111. remote_file=${file#"$rclone_source/"}
  112. rclone_target_file="${rclone_target}/${remote_file}"
  113. echo "Generating Link for: ${rclone_target_file}"
  114. file_link=$(rclone link "${rclone_target_file}")
  115. link_rc=$?
  116. if [[ "${rclone_allow_failure}" = "true" && $link_rc -gt 0 ]]; then
  117. echo "Rclone linking failed. Switching to next target."
  118. continue
  119. fi
  120. file_links+=( "${rclone_target_file}" "${file_link}" )
  121. done
  122. fi
  123. if [[ "${rclone_allow_failure}" = "true" ]]; then
  124. set -e
  125. fi
  126. echo "rclone job complete for ${rclone_source} -> ${rclone_target}"
  127. done
  128. # Arithmetic expression to check size of array
  129. if (( ${#file_links[@]} )); then
  130. echo "File Links:" "${file_links[@]}"
  131. # shellcheck disable=2068
  132. metadata=$(printf '{"name": "%s", "value": "%s"},' ${file_links[@]})
  133. metadata="[${metadata::-1}]"
  134. links_json=$( echo -n "{\"links\":${metadata}}" | jq -r . )
  135. links_json_file="${TMPDIR}/.rclone_links.json"
  136. echo "$links_json" > "${links_json_file}"
  137. if [[ -n "${rclone_link_destination}" ]]; then
  138. rclone_link_destination_subdir=""
  139. if [ -n "$rclone_link_destination_subdir_file" ]; then
  140. echo "Looking in ${source}/${rclone_link_destination_subdir_file} for subdir to use"
  141. rclone_link_destination_subdir=$(head -n 1 < "${source}/${rclone_link_destination_subdir_file}")
  142. fi
  143. if [[ -z "${rclone_link_destination_subdir}" ]]; then
  144. rclone_link_target="${rclone_link_destination}"
  145. else
  146. rclone_link_target="${rclone_link_destination}/${rclone_link_destination_subdir}"
  147. fi
  148. echo "Link Target: ${rclone_link_target}"
  149. rclone copy ${links_json_file} ${rclone_link_target} --progress --stats=2s
  150. fi
  151. cat "${links_json_file}"
  152. jq -n "{
  153. version: {
  154. build: $( echo -n "${BUILD_ID}" | jq -R .),
  155. digest: $( echo -n "sha256:${sha256}" | jq -R . )
  156. },
  157. metadata: ${metadata}
  158. }" >&3
  159. else
  160. jq -n "{
  161. version: {
  162. build: $( echo -n "${BUILD_ID}" | jq -R .),
  163. digest: $( echo -n "sha256:${sha256}" | jq -R . )
  164. }
  165. }" >&3
  166. fi